Bug 1738802 - python-igor depends on Python 2
Summary: python-igor depends on Python 2
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: python-igor
Version: 31
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Zbigniew Jędrzejewski-Szmek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: F31_PY2REMOVAL 1739520
TreeView+ depends on / blocked
 
Reported: 2019-08-08 08:27 UTC by Lumír Balhar
Modified: 2019-11-07 10:16 UTC (History)
1 user (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-11-07 10:16:52 UTC
Type: Bug


Attachments (Terms of Use)

Description Lumír Balhar 2019-08-08 08:27:08 UTC
Python 2.7 will reach end-of-life in January 2020, over 9 years after it was released. This falls within the Fedora 31 lifetime.
Packages that depend on Python 2 are being switched to Python 3 or removed from Fedora: https://fedoraproject.org/wiki/Changes/F31_Mass_Python_2_Package_Removal#Information_on_Remaining_Packages
Python 2 will be retired in Fedora 32: https://fedoraproject.org/wiki/Changes/RetirePython2

To help planning, we'd like to know the plans for python-igor's future. Specifically:


- What is the reason for the Python2 dependency? (Is it software written in Python, or does it just provide Python bindings, or use Python in the build system or test runner?) 

- What are the upstream/community plans/timelines regarding Python 3?

- What is the guidance for porting to Python 3? (Assuming that there is someone who generally knows how to port to Python 3, but doesn't know anything about the particular package, what are the next steps to take?)


This bug is filed semi-automatically, and might not have all the context specific to python-igor.
If you need anything from us, or something is unclear, please mention it here.

Thank you.

Comment 1 Ben Cotton 2019-08-13 17:11:25 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to '31'.

Comment 2 Ben Cotton 2019-08-13 17:33:49 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to 31.

Comment 3 Lumír Balhar 2019-08-15 08:14:22 UTC
Please answer the above questions. If you don't, the package can be orphaned: https://fedoraproject.org/wiki/Changes/F31_Mass_Python_2_Package_Removal#Information_on_Remaining_Packages

If you need any information or help, or if you need some more time, please let us know.

Comment 4 Zbigniew Jędrzejewski-Szmek 2019-08-16 06:46:10 UTC
The package needs some work to make python3 support fully functional. I tried to make a PR a few years ago, but there were some issues with bytes formatting that never got resolved properly. Help would be welcome.

Comment 5 Zbigniew Jędrzejewski-Szmek 2019-08-22 08:27:56 UTC
I'll get to this at some point...

Comment 6 Lumír Balhar 2019-08-30 05:35:46 UTC
Thanks for the info.

The current plan is to remove packages with dependency on Python 2 from Fedora 32 in the middle of November 2019. If you want to keep your package in Fedora after that date and you cannot port it to Python 3 yet, you need to request a FESCo exception for the package and all its Python 2 dependencies (even transitive) [1]. If you don't want to maintain it anymore, and nothing in Fedora uses it, you can retire it or just remove the Python 2 part from it (subpackage, module, bindings, etc.).

If you're considering filing the exception request, let us know. We can help (for example, we can help find all the dependencies).

[1] https://fedoraproject.org/wiki/Changes/RetirePython2#FESCo_exceptions

Comment 7 Lumír Balhar 2019-10-17 07:11:01 UTC
Hello.

I'd like to help you here so I did some testing and here is my plan. I've read the latest build log and it seems that the tests are failing with both Pythons just because of different formatting (newer numpy, "b" prefix for bytes objects, "L" suffix for integers). Source code itself looks Python 3 compatible and I did also some tests of CLI tools igorpackedexperiment and igorbinarywave with the test data from upstream and Python 3 and everything looks good.

So, the plan is:

1. Move igorpackedexperiment and igorbinarywave to python3- subpackage, change shebangs
2. Remove python2- subpackage

The optional third step could be to port all tests to Python 3 (downstream). I can do that but it depends on you whether you want to maintain a patch like this or not.

If you agree, I'll prepare a PR.

Comment 8 Zbigniew Jędrzejewski-Szmek 2019-10-17 08:00:42 UTC
Sure, if you can prep something that mostly works, I'll be happy to have it. (The package does
not change upstream, so any local patch will not require "maintenance". And I'm pretty
sure upstream will be happy to take it anyway.)

Comment 9 Lumír Balhar 2019-10-17 08:54:55 UTC
Pull request: https://src.fedoraproject.org/rpms/python-igor/pull-request/2

I'll take a look at the tests soon.

Comment 10 Lumír Balhar 2019-10-21 11:48:19 UTC
Patch for doctests: https://src.fedoraproject.org/rpms/python-igor/pull-request/3

Comment 11 Lumír Balhar 2019-11-07 10:16:52 UTC
It seems that everything works here. Thank you!


Note You need to log in before you can comment on or make changes to this bug.